import { DeepPartial } from "ts-essentials";
import AbstractBundler from "./AbstractBundler";
import BundlerConfig from "./interfaces/BundlerConfig";
import { EnvironmentTypes } from "./types/EnvironmentTypes";
export default class WebBundler extends AbstractBundler {
    constructor(mode?: EnvironmentTypes, config?: DeepPartial<BundlerConfig>);
    entry(name: string, entryPaths: Array<string>): this;
}
