"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Plugin_1 = __importDefault(require("./Plugin"));
var webpack_1 = require("webpack");
var DefineEnvironmentVariables = (function (_super) {
    __extends(DefineEnvironmentVariables, _super);
    function DefineEnvironmentVariables() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefineEnvironmentVariables.prototype.register = function () {
        var variables = {
            app: {
                env: this.bundler.env.mode,
            },
        };
        for (var variableName in this.options.variables) {
            variables[variableName] = Object.assign({}, variables[variableName], this.options.variables[variableName]);
        }
        this.bundler.webpackChain.plugin("variables").use(webpack_1.DefinePlugin, [
            {
                __ENV_VARIABLES__: this.stringify(variables),
            },
        ]);
    };
    DefineEnvironmentVariables.prototype.stringify = function (variables) {
        for (var variable in variables) {
            var tempVariable = variables[variable];
            if (typeof variables[variable] === "object") {
                variables[variable] = this.stringify(tempVariable);
                continue;
            }
            variables[variable] = JSON.stringify(variables[variable]);
        }
        return variables;
    };
    return DefineEnvironmentVariables;
}(Plugin_1.default));
exports.default = DefineEnvironmentVariables;
//# sourceMappingURL=DefineEnvironmentVariables.js.map